/* tslint:disable */
/* eslint-disable */
/**
 * POS API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface AddReceiptWebhook
 */
export interface AddReceiptWebhook {
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhook
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhook
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhook
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhook
     */
    'contact_id': string;
    /**
     * 
     * @type {object}
     * @memberof AddReceiptWebhook
     */
    'attributes'?: object;
    /**
     * 
     * @type {AddReceiptWebhookReceipt}
     * @memberof AddReceiptWebhook
     */
    'receipt': AddReceiptWebhookReceipt;
}
/**
 * 
 * @export
 * @interface AddReceiptWebhookReceipt
 */
export interface AddReceiptWebhookReceipt {
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhookReceipt
     */
    'status': string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhookReceipt
     */
    'error'?: string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhookReceipt
     */
    'location_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhookReceipt
     */
    'time'?: string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhookReceipt
     */
    'date'?: string;
    /**
     * 
     * @type {string}
     * @memberof AddReceiptWebhookReceipt
     */
    'total'?: string;
}
/**
 * 
 * @export
 * @interface AnybillConfiguration
 */
export interface AnybillConfiguration {
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'client_id': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'token_url': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof AnybillConfiguration
     */
    'updated_at': string;
}
/**
 * 
 * @export
 * @interface AvailableActionsResponse
 */
export interface AvailableActionsResponse {
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'anybill': Array<AvailableActionsResponseAnybillEnum>;
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'custom': Array<AvailableActionsResponseCustomEnum>;
}

export const AvailableActionsResponseAnybillEnum = {
    GetReceipt: 'get_receipt'
} as const;

export type AvailableActionsResponseAnybillEnum = typeof AvailableActionsResponseAnybillEnum[keyof typeof AvailableActionsResponseAnybillEnum];
export const AvailableActionsResponseCustomEnum = {
    GetReceipt: 'get_receipt',
    AddReceipt: 'add_receipt'
} as const;

export type AvailableActionsResponseCustomEnum = typeof AvailableActionsResponseCustomEnum[keyof typeof AvailableActionsResponseCustomEnum];

/**
 * 
 * @export
 * @interface BongoReceipt
 */
export interface BongoReceipt {
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'status': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'error': string;
    /**
     * 
     * @type {object}
     * @memberof BongoReceipt
     */
    'receipt_data': object;
    /**
     * 
     * @type {number}
     * @memberof BongoReceipt
     */
    'attempt': number;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'contact_id': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'receipt_url': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof BongoReceipt
     */
    'updated_at': string;
}
/**
 * 
 * @export
 * @interface CheckReceiptRequest
 */
export interface CheckReceiptRequest {
    /**
     * 
     * @type {string}
     * @memberof CheckReceiptRequest
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof CheckReceiptRequest
     */
    'contact_id': string;
    /**
     * 
     * @type {string}
     * @memberof CheckReceiptRequest
     */
    'receipt_url': string;
    /**
     * 
     * @type {string}
     * @memberof CheckReceiptRequest
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof CheckReceiptRequest
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof CheckReceiptRequest
     */
    'organization_id': string;
    /**
     * 
     * @type {number}
     * @memberof CheckReceiptRequest
     */
    'attempt': number;
}
/**
 * 
 * @export
 * @interface ContactData
 */
export interface ContactData {
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    'contact_id': string;
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    'gateway_id': string;
    /**
     * 
     * @type {string}
     * @memberof ContactData
     */
    'conversation_id': string;
}
/**
 * 
 * @export
 * @interface CreateAnybillConfigRequest
 */
export interface CreateAnybillConfigRequest {
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'client_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'client_secret': string;
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'password': string;
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'token_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreateAnybillConfigRequest
     */
    'webhook_secret': string;
}
/**
 * 
 * @export
 * @interface CustomHandler
 */
export interface CustomHandler {
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'type': CustomHandlerTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'url': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'secret'?: string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'secret_header'?: string;
    /**
     * 
     * @type {boolean}
     * @memberof CustomHandler
     */
    'secret_configured': boolean;
    /**
     * 
     * @type {object}
     * @memberof CustomHandler
     */
    'attributes'?: object;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'updated_at': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'organization_id': string;
}

export const CustomHandlerTypeEnum = {
    GetReceipt: 'get_receipt',
    AddReceipt: 'add_receipt'
} as const;

export type CustomHandlerTypeEnum = typeof CustomHandlerTypeEnum[keyof typeof CustomHandlerTypeEnum];

/**
 * 
 * @export
 * @interface GetReceiptWebhook
 */
export interface GetReceiptWebhook {
    /**
     * 
     * @type {string}
     * @memberof GetReceiptWebhook
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof GetReceiptWebhook
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof GetReceiptWebhook
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof GetReceiptWebhook
     */
    'contact_id': string;
    /**
     * 
     * @type {object}
     * @memberof GetReceiptWebhook
     */
    'attributes'?: object;
    /**
     * 
     * @type {GetReceiptWebhookReceipt}
     * @memberof GetReceiptWebhook
     */
    'receipt': GetReceiptWebhookReceipt;
}
/**
 * 
 * @export
 * @interface GetReceiptWebhookReceipt
 */
export interface GetReceiptWebhookReceipt {
    /**
     * 
     * @type {string}
     * @memberof GetReceiptWebhookReceipt
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof GetReceiptWebhookReceipt
     */
    'file_url': string;
}
/**
 * 
 * @export
 * @interface WebhookRequest
 */
export interface WebhookRequest {
    /**
     * 
     * @type {string}
     * @memberof WebhookRequest
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof WebhookRequest
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof WebhookRequest
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof WebhookRequest
     */
    'contact_id': string;
    /**
     * 
     * @type {object}
     * @memberof WebhookRequest
     */
    'attributes'?: object;
    /**
     * 
     * @type {AddReceiptWebhookReceipt}
     * @memberof WebhookRequest
     */
    'receipt': AddReceiptWebhookReceipt;
}

/**
 * AnybillApi - axios parameter creator
 * @export
 */
export const AnybillApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create Anybill configuration
         * @param {string} oid Organization ID
         * @param {CreateAnybillConfigRequest} [createAnybillConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAnybillConfiguration: async (oid: string, createAnybillConfigRequest?: CreateAnybillConfigRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('createAnybillConfiguration', 'oid', oid)
            const localVarPath = `/integrations/anybill/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createAnybillConfigRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Anybill configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAnybillConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('deleteAnybillConfiguration', 'oid', oid)
            const localVarPath = `/integrations/anybill/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Anybill configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAnybillConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('getAnybillConfiguration', 'oid', oid)
            const localVarPath = `/integrations/anybill/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AnybillApi - functional programming interface
 * @export
 */
export const AnybillApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AnybillApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create Anybill configuration
         * @param {string} oid Organization ID
         * @param {CreateAnybillConfigRequest} [createAnybillConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createAnybillConfiguration(oid: string, createAnybillConfigRequest?: CreateAnybillConfigRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AnybillConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createAnybillConfiguration(oid, createAnybillConfigRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Anybill configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteAnybillConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteAnybillConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Anybill configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAnybillConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AnybillConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAnybillConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AnybillApi - factory interface
 * @export
 */
export const AnybillApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AnybillApiFp(configuration)
    return {
        /**
         * 
         * @summary Create Anybill configuration
         * @param {string} oid Organization ID
         * @param {CreateAnybillConfigRequest} [createAnybillConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createAnybillConfiguration(oid: string, createAnybillConfigRequest?: CreateAnybillConfigRequest, options?: any): AxiosPromise<AnybillConfiguration> {
            return localVarFp.createAnybillConfiguration(oid, createAnybillConfigRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Anybill configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteAnybillConfiguration(oid: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteAnybillConfiguration(oid, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Anybill configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAnybillConfiguration(oid: string, options?: any): AxiosPromise<AnybillConfiguration> {
            return localVarFp.getAnybillConfiguration(oid, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * AnybillApi - object-oriented interface
 * @export
 * @class AnybillApi
 * @extends {BaseAPI}
 */
export class AnybillApi extends BaseAPI {
    /**
     * 
     * @summary Create Anybill configuration
     * @param {string} oid Organization ID
     * @param {CreateAnybillConfigRequest} [createAnybillConfigRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnybillApi
     */
    public createAnybillConfiguration(oid: string, createAnybillConfigRequest?: CreateAnybillConfigRequest, options?: AxiosRequestConfig) {
        return AnybillApiFp(this.configuration).createAnybillConfiguration(oid, createAnybillConfigRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Anybill configuration
     * @param {string} oid Organization ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnybillApi
     */
    public deleteAnybillConfiguration(oid: string, options?: AxiosRequestConfig) {
        return AnybillApiFp(this.configuration).deleteAnybillConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Anybill configuration
     * @param {string} oid Organization ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AnybillApi
     */
    public getAnybillConfiguration(oid: string, options?: AxiosRequestConfig) {
        return AnybillApiFp(this.configuration).getAnybillConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * BongoApi - axios parameter creator
 * @export
 */
export const BongoApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Check receipt
         * @param {CheckReceiptRequest} [checkReceiptRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        bongoCheckReceipt: async (checkReceiptRequest?: CheckReceiptRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/integrations/bongo/check-receipt`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(checkReceiptRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * BongoApi - functional programming interface
 * @export
 */
export const BongoApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = BongoApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Check receipt
         * @param {CheckReceiptRequest} [checkReceiptRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async bongoCheckReceipt(checkReceiptRequest?: CheckReceiptRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BongoReceipt>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.bongoCheckReceipt(checkReceiptRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * BongoApi - factory interface
 * @export
 */
export const BongoApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = BongoApiFp(configuration)
    return {
        /**
         * 
         * @summary Check receipt
         * @param {CheckReceiptRequest} [checkReceiptRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        bongoCheckReceipt(checkReceiptRequest?: CheckReceiptRequest, options?: any): AxiosPromise<BongoReceipt> {
            return localVarFp.bongoCheckReceipt(checkReceiptRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * BongoApi - object-oriented interface
 * @export
 * @class BongoApi
 * @extends {BaseAPI}
 */
export class BongoApi extends BaseAPI {
    /**
     * 
     * @summary Check receipt
     * @param {CheckReceiptRequest} [checkReceiptRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BongoApi
     */
    public bongoCheckReceipt(checkReceiptRequest?: CheckReceiptRequest, options?: AxiosRequestConfig) {
        return BongoApiFp(this.configuration).bongoCheckReceipt(checkReceiptRequest, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * CustomApi - axios parameter creator
 * @export
 */
export const CustomApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteCustomHandler: async (channelId: string, id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('deleteCustomHandler', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers/{id}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteOrganizationCustomHandler: async (id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteOrganizationCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomHandler: async (channelId: string, id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('getCustomHandler', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('getCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers/{id}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getOrganizationCustomHandler: async (id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getOrganizationCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('getOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listCustomHandlers: async (channelId: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('listCustomHandlers', 'channelId', channelId)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('listCustomHandlers', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrganizationCustomHandlers: async (orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('listOrganizationCustomHandlers', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationWebhook: async (type: OrganizationWebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'type' is not null or undefined
            assertParamExists('organizationWebhook', 'type', type)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('organizationWebhook', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/webhooks/{type}`
                .replace(`{${"type"}}`, encodeURIComponent(String(type)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(webhookRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerCustomHandler: async (channelId: string, orgId: string, customHandler?: CustomHandler, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('registerCustomHandler', 'channelId', channelId)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('registerCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(customHandler, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerOrganizationCustomHandler: async (orgId: string, customHandler?: CustomHandler, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('registerOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(customHandler, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook: async (channelId: string, type: WebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('webhook', 'channelId', channelId)
            // verify required parameter 'type' is not null or undefined
            assertParamExists('webhook', 'type', type)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('webhook', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/webhooks/{type}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"type"}}`, encodeURIComponent(String(type)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(webhookRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CustomApi - functional programming interface
 * @export
 */
export const CustomApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CustomApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteCustomHandler(channelId, id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteOrganizationCustomHandler(id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCustomHandler(channelId, id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getOrganizationCustomHandler(id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listCustomHandlers(channelId: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CustomHandler>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listCustomHandlers(channelId, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listOrganizationCustomHandlers(orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CustomHandler>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listOrganizationCustomHandlers(orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationWebhook(type, orgId, webhookRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.registerCustomHandler(channelId, orgId, customHandler, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.registerOrganizationCustomHandler(orgId, customHandler, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async webhook(channelId: string, type: WebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.webhook(channelId, type, orgId, webhookRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CustomApi - factory interface
 * @export
 */
export const CustomApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CustomApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteCustomHandler(channelId: string, id: string, orgId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteCustomHandler(channelId, id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteOrganizationCustomHandler(id: string, orgId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteOrganizationCustomHandler(id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomHandler(channelId: string, id: string, orgId: string, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.getCustomHandler(channelId, id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getOrganizationCustomHandler(id: string, orgId: string, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.getOrganizationCustomHandler(id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listCustomHandlers(channelId: string, orgId: string, options?: any): AxiosPromise<Array<CustomHandler>> {
            return localVarFp.listCustomHandlers(channelId, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrganizationCustomHandlers(orgId: string, options?: any): AxiosPromise<Array<CustomHandler>> {
            return localVarFp.listOrganizationCustomHandlers(orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options?: any): AxiosPromise<void> {
            return localVarFp.organizationWebhook(type, orgId, webhookRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.registerCustomHandler(channelId, orgId, customHandler, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.registerOrganizationCustomHandler(orgId, customHandler, options).then((request) => request(axios, basePath));
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {WebhookRequest} [webhookRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook(channelId: string, type: WebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options?: any): AxiosPromise<void> {
            return localVarFp.webhook(channelId, type, orgId, webhookRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * CustomApi - object-oriented interface
 * @export
 * @class CustomApi
 * @extends {BaseAPI}
 */
export class CustomApi extends BaseAPI {
    /**
     * 
     * @summary Delete custom handler
     * @param {string} channelId 
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public deleteCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).deleteCustomHandler(channelId, id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete organization custom handler
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public deleteOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).deleteOrganizationCustomHandler(id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get custom handler
     * @param {string} channelId 
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public getCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).getCustomHandler(channelId, id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get organization custom handler
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public getOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).getOrganizationCustomHandler(id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List custom handlers
     * @param {string} channelId 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public listCustomHandlers(channelId: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).listCustomHandlers(channelId, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List organization custom handlers
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public listOrganizationCustomHandlers(orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).listOrganizationCustomHandlers(orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Webhook endpoint for external systems
     * @summary Webhook (organization)
     * @param {OrganizationWebhookTypeEnum} type 
     * @param {string} orgId 
     * @param {WebhookRequest} [webhookRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).organizationWebhook(type, orgId, webhookRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Register custom handler
     * @param {string} channelId 
     * @param {string} orgId 
     * @param {CustomHandler} [customHandler] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).registerCustomHandler(channelId, orgId, customHandler, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Register organization custom handler
     * @param {string} orgId 
     * @param {CustomHandler} [customHandler] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).registerOrganizationCustomHandler(orgId, customHandler, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Webhook endpoint for external systems
     * @summary Webhook
     * @param {string} channelId 
     * @param {WebhookTypeEnum} type 
     * @param {string} orgId 
     * @param {WebhookRequest} [webhookRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public webhook(channelId: string, type: WebhookTypeEnum, orgId: string, webhookRequest?: WebhookRequest, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).webhook(channelId, type, orgId, webhookRequest, options).then((request) => request(this.axios, this.basePath));
    }
}

/**
 * @export
 */
export const OrganizationWebhookTypeEnum = {
    GetReceipt: 'get_receipt'
} as const;
export type OrganizationWebhookTypeEnum = typeof OrganizationWebhookTypeEnum[keyof typeof OrganizationWebhookTypeEnum];
/**
 * @export
 */
export const WebhookTypeEnum = {
    GetReceipt: 'get_receipt'
} as const;
export type WebhookTypeEnum = typeof WebhookTypeEnum[keyof typeof WebhookTypeEnum];


/**
 * SettingsApi - axios parameter creator
 * @export
 */
export const SettingsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableActions: async (organizationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('getAvailableActions', 'organizationId', organizationId)
            const localVarPath = `/settings/organizations/{organizationId}/available-actions`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SettingsApi - functional programming interface
 * @export
 */
export const SettingsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SettingsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAvailableActions(organizationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AvailableActionsResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAvailableActions(organizationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SettingsApi - factory interface
 * @export
 */
export const SettingsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SettingsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableActions(organizationId: string, options?: any): AxiosPromise<AvailableActionsResponse> {
            return localVarFp.getAvailableActions(organizationId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * SettingsApi - object-oriented interface
 * @export
 * @class SettingsApi
 * @extends {BaseAPI}
 */
export class SettingsApi extends BaseAPI {
    /**
     * 
     * @summary Get available actions for organization
     * @param {string} organizationId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SettingsApi
     */
    public getAvailableActions(organizationId: string, options?: AxiosRequestConfig) {
        return SettingsApiFp(this.configuration).getAvailableActions(organizationId, options).then((request) => request(this.axios, this.basePath));
    }
}



